; ARCADEmini firmware
; part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
; Copyright (C) 2003-2006 Stefan Schuermans <1stein@schuermans.info>
; may be used for non-commercial purposes in unmodified form if:
; may be used for non-commercial purposes in modified form if:
;   - this copyright header is left unchanged
;   - and every modification is sent to the copyright holder in source code form
;   - and the source code of the modification may be used in every way be the copyright holder

	TITLE		"I/O pin declarations for ARCADEmini firmware"



;===========================================================================================
; I/O pins
;===========================================================================================

; LED pins (output)
#define	PORT_COL0	LATE		; RE0 = LED colum 0, ..., RE7 = LED column 7
#define	PORT_COL1	LATD		; RD0 = LED colum 8, ..., RD7 = LED column 15
#define	PORT_COL2	LATC		; RC0 = LED colum 16, ..., RC7 = LED column 23
#define	PORT_ROW0	LATF		; RF0 = LED row 0, ..., RF7 = LED row 7
#define	PORT_ROW1	LATJ		; RJ0 = LED row 8, ..., RJ7 = LED row 15
#define	PORT_ROW2_COL3	LATA		; RA0 = LED row 16, ..., RA3 = LED row 19
					; RA4 = LED column 24, RA5 = LED column 25
					; RA6 written with 0 (can't be used as output)

; some shared (SH) pins
; - compact flash (CF) pins
; - USB chip USBN9604 (USB) pins
; - input pins for keys (PORT_SH_D)
; - output pins for snes keys (clock, load) (PORT_SH_D_CLK/LOAD)
; - input pin for power supply detection (PIN_SH_A_PWR)
; - input pin for snes keys (PIN_SH_A_SNES0/1)
#define	PORT_SH_D	PORTH		; RH0 = CF D00, ..., RH7 = CF D07 (bidirectional)
#define PORT_SH_D_TRIS	TRISH		; TRIS register for above port (to change input/output)
#define PORT_SH_D_TR_I	b'11111111'	; value for TRIS register to make above port input
#define PORT_SH_D_TR_O	b'00000000'	; value for TRIS register to make above port output
#define PORT_SH_D_CLK	LATH,0		; D00 = snes clock
#define PORT_SH_D_LOAD	LATH,1		; D01 = snes load
#define	PORT_SH_A	PORTG		; RG0 = CF A00, ..., RG2 = CF A02 (bidirectional)
					; RG3..4 written with 0 (can't be used as output)
#define PORT_SH_A_TRIS	TRISG		; TRIS register for above port (to change input/output)
#define PORT_SH_A_TR_I	b'00011111'	; value for TRIS register to make above port input
#define PORT_SH_A_TR_O	b'00011000'	; value for TRIS register to make above port output
#define	PIN_SH_A_PWR	PORT_SH_A,0	; input pin for power supply detection
#define	PIN_SH_A_SNES0	PORT_SH_A,1	; input pin for 1st SNES pad
#define	PIN_SH_A_SNES1	PORT_SH_A,2	; input pin for 2nd SNES pad
#define	PIN_SH_nOE	LATB,0		; RB0 = CF nOE, USBN nOE (output)
#define	PIN_SH_nWE	LATB,1		; RB1 = CF nWE, USBN nWE (output)
#define	PIN_CF_nCE	LATB,2		; RB2 = CF nCE (output)
#define	PIN_CF_RESET	LATB,3		; RB3 = CF nRESET (output)
#define	PIN_USB_nCS	LATB,4		; RB4 = USBN nCS (output)
#define	PIN_USB_nRESET	LATB,5		; RB5 = USBN nRESET (output)
#define	PIN_CF_nCD1	PORTG,3		; RG3 = CF nCD1 (input)
#define	PIN_CF_RDY	PORTG,4		; RG4 = CF RDY (input)



; RA6 used for oscillator
; RB6..7 used for serial in circuit programming and debugging


